(function (Drupal) {
  /**
   * @type {{attach: Drupal.behaviors.initOuibounce.attach}}
   */
  Drupal.behaviors.initOuibounce = {
    attach: function (context, settings) {
      once('init-ouibounce', document.getElementById('ouibounce-exit-modal'), context).forEach(function (item) {
        const config = settings['ouibounce'];
        const modal = item.getElementsByClassName('ouibounce-exit-modal__layer')[0];
        const backdrop = item.getElementsByClassName('ouibounce-exit-modal__backdrop')[0];
        const footer = modal ? modal.getElementsByClassName('ouibounce-exit-modal__layer-footer')[0] : null;

        ouibounce(item, {
          sensitivity: config['sensitivity'],
          aggressive: config['aggressive_mode'],
          timer: config['timer'],
          delay: config['delay'],
          cookieExpire: config['cookie_expiration'],
          cookieDomain: config['cookie_domain'],
          cookieName: config['cookie_name'],
          sitewide: config['sitewide_cookie'],
          callback: function () {},
        });

        if (backdrop) {
          backdrop.addEventListener('click', function (e) {
            item.style.display = 'none';
          });
        }

        if (footer) {
          footer.addEventListener('click', function (e) {
            item.style.display = 'none';
          });
        }

        if (modal) {
          modal.addEventListener('click', function (e) {
            e.stopPropagation();
          });
        }
      });
    },
  };
})(Drupal);
